# -*- coding: utf-8 -*-

###########################################################################
## 程序设计 danscort yu (c)2021
## www.phoenixp2p.com
##
## sync and restore program for XFile server
## 
###########################################################################
###########################################################################
## 本代码是基于xftp.py修改而来,因此看着可能有点怪有点傻, 这个代码为XFile服务器提供类似同步和备份工具
## 同时实现了备份和同步操作的基本功能 请根据需要进行修改 , 例如 windows 系统允许文件名和目录中包含空格,大小写不敏感 而Linux不支持包含空格,大小写敏感 
## 由于XFile服务器支持多种操作系统,支持的文件系统更是超级多,我们无法象商用nas一样限制在某个文件系统而利用该系统特性,我们的工具也只能说实现了基础的备份和同步和恢复功能
## 一般,如果你的XFile是windows平台搭建,而客户端是Linux,那么你最好人肉保证同一目录下不存在类似 T123.txt t123.txt 这种只有大小写不同的文件,否则将出问题
## 同样 如果你的XFile是linux平台搭建,那么你要备份或者同步的目录以及下面的文件名,不能包含空格等,否则会失败
## 另外,有些特殊的目录,例如驱动程序的目录属性是系统,那么同步模式下本地的删除操作也可能失败,这是python库里的函数本身问题,要解决需要一套非常复杂的判断递归等,我偷懒了
## 使用python实现这个功能,是为了方便跨平台,同时提供各位有兴趣的朋友,根据自己的需要进行修改,这个xfile.py是个基础,你想扩展自己的应用,只需要import xfile.py就可以调用它了
## 但是请注意 本代码仅支持XFile的备份恢复模式,其他标准Ftp服务器软件是无法支持的,因为使用了大量的XFile扩展指令
## 代码中已经提供了xfiledns程序来配合自动获取服务器的动态ipv6地址，请根据不同的系统选择不同的版本，如果只是在内网使用，则不需要打开这个功能
## 
## 之所以将代码写成一个个函数方式,是因为我们希望提供一个基础的python版本XFile客户端功能实现,方便各位有兴趣的朋友进行扩展编程
## 特别提醒,python 3.7/3.8/3.9 的ftplib 库的TLS/SSL文件加密传输存在bug,这是ftplib库本身代码的bug,不要启用tls上传文件,否则会卡死超时,具体原因stackoverflow上已经有明确的说明,但是始终没有被修复,除非你人肉hack进去修改ftplib库里的storBinary等函数的实现,否则无解
## 此外,python自带的ftplib 实现的很简陋,在连接的时候,如果150后无法立即完成,会陷入睡眠等待 而不是异步或者后台消息,导致某些时候出现卡滞,这是python ftplib本身的问题,如果要优化,那么会对apache commonnet产生影响 评估的结果是不调整,因为这是ftplib实现做的不好
## 您可以任意修改本代码 但是请保留本说明部分, 部分代码可能写的比较sb,因为我是把python当脚本语言来写的，而且前面有部分遗留参数，我懒的折腾
## 作者: danscort@phoenixp2p.com
## 最后编辑:2021.07
##
###########################################################################
import sys
import os
import time
import socket
import ftplib
from ftplib import FTP
from ftplib import FTP_TLS
import configparser
import hashlib
import random
import shutil
import subprocess
from datetime import datetime, timezone


###########################################################################
## Sync and restore program for XFile
## XFile server version must not below  2.75
## 为什么要强调服务器版本要求2.75 (2021.07.01) ,这是因为2.75版本开始引入了服务器反向验证技术，这样从技术上彻底堵住了密罐服务器的可能 而且放开和修复了几处类似根目录下上传文件等改进
###########################################################################

##以下是全局变量部分
##ctx = ssl._create_stdlib_context(ssl.PROTOCOL_TLSv1_2) 
## 然后可以强制 context=ctx 但是我不推荐 因为有些服务器可能只支持到1.0/1.1 
## 再说 动态ip 这种tls 根本就是防百姓不防xxx的
_ftp = FTP()
_ftps = FTP_TLS()
_mbcon = True
# 如果是正式发行版本 请修改为 _debugmode=False
_debugmode = False

#随机数 XFile专用的随机数字符串
_srandomcode = "0"

#2020.10新增加的 用来保存登录口令
_ssha256pass = ""
#下面这个开关 决定是否使用最后修改时间作为文件是否相同或者需要更新的条件 默认启用 但是有些古董级的文件系统是不支持最后修改时间参数的 根据需要关闭(False)
_bcomparemodtime=True
#下面这个开关 用来决定同步模式下 是否删除服务器端多余的目录和文件 这是个危险的操作 默认是启用的 你可以关闭它(False)
_bdeletedirfilesyncmode=True

#配置文件 默认的配置文件名  不建议修改它
set_configfile="xfilecfg.ini"
#xfiledns指定的配置文件名
set_cfgxfilednsname="Progset.ini"
#服务器地址 从配置文件读取
set_serveraddr=""
#64位随机数字 这是客户端我们自己设置的64位16进制随机字符串 小写 用于配合账户反馈码反蜜罐服务器
_clientrandom64=""
#反向验证码 服务器反馈码 需要在获取随机数的时候同时生成 用于反向验证服务器就是我们想登录的服务器 这是个非常强悍的功能
_serverrespcode=""

#服务器端口
set_serverport=0
#服务器握手码 如果为0 则代表不用验证
set_shakecode=0
#登录用户名
set_username=""
#登录密码
set_password=""
#是否启用tls/ssl加密
set_tls=False
#下面这个参数无效了 因为目前版本都是自动识别判断了
set_sha256=False
#是否启用服务器反向验证（账户反馈码验证） 该功能要求服务器版本至少2.71 否则会失败 服务器反向验证（账户反馈码）用于解决个人动态ip缺少证书链，使用本手段来识别正确服务器
set_responsecode=""
#是否读取xfiledns产生的结果 可以通过类似xfiledns.exe > ./xfileaddr.txt 来产生
set_addrfromdns=False
#xfiledns结果文件的路径 格式 200 服务器地址 注意下windows 和linux目录字符区别 sys.path[0]+"\\xfileaddr.txt"
set_dnsfile=""
#是否使用同步模式 默认为备份模式 警告 如果你启用了同步模式 但是ftp目标目录设置错误 会导致目标目录下的文件目录被删除 因此需要特别小心 一般不建议使用同步模式
set_syncmode=False
#服务器远程备份目录
set_serverbkdir="/"
#本地需要备份或者恢复的目录
set_localbkdir=""
#服务器远程备份目录2
set_serverbkdir2="/"
#本地需要备份或者恢复的目录2
set_localbkdir2=""





#由于这套代码是从xftp python直接增删而来,为了保持缩进等的一致性 这里干脆用了一个完全无关的类来代替
class MainClass:
    #全局变量可以调整为类内部变量,依然保持全局的唯一原因是我不想费太多时间修改,偷懒了
    def __init__(self) -> None:
        pass

    #这个函数在获取随机数字前调用
    def FuncMakeAcctRandom64(self):
        global _clientrandom64
        global _debugmode
        #我们需要一个随机数字 如果你不设置随机数字也可以 但是万一蜜罐服务器针对你,并且拦截了你所有的类似握手码 随即数等进行模拟 则必须使用用户端的随机数字进行鉴别 可以反掉这种针对性的蜜罐
        irandom1=int(time.time())%10000000
        irandom1+=( 1 + int(time.time())%500)*2000000
        irandom1+=random.randint(103,1000000000)
            
        if(irandom1<0):
            irandom1=abs(irandom1)
        if(irandom1<=10):
            irandom1+=random.randint(9218,88888888)
        str01="{:x}".format(irandom1) 
        #使用16进制字符串吧 如果要简化 也可以使用10进制当原始内容 
        str01+="_Good"
        if(_debugmode):
            print("random 256 raw str="+str01)
        md256 = hashlib.sha256()
        md256.update(str01.encode(encoding='utf-8'))
        str01 = md256.hexdigest( ).lower() 
        _clientrandom64="8"
        #这是防止出现字符串开头是0的情况 因此开头用8 这个随机数字是个64位数字 16进制 因此最多16个字符 这里用15个长度 
        _clientrandom64+=str01[50:] 
        if(_debugmode):
            print("Resp random number =" + _clientrandom64)
        return    

    ##检查目录是否存在 在执行同步或者备份前先判断 否则出错
    def FuncTestDirExist(self,sdir1:str)->bool:
        #测试目录是否存在
        if(len(sdir1)<=0):
            return False
        if(os.path.isdir(sdir1)):
            return True
        return False

    ##检测目录是否可以读写
    def FuncTestDirRW(self,sdir1:str="",bread:bool=True)->bool:
        #测试目录是否可以读写   
        if(self.FuncTestDirExist(sdir1)==False):
            return False
        #否则 测试目录是否可以读写
        # 
        if(bread):
            return os.access(sdir1,os.R_OK)
        else:
            return os.access(sdir1,os.W_OK)




    #读取配置文件 用于登录并执行
    def FuncLoadConfigFile(self,bsig:bool=True)->bool:
        #这里是为了保持兼容  
        #
        global _debugmode
        global set_configfile
        global set_serveraddr
        global set_username
        global set_password
        global set_serverport
        global set_tls
        global set_shakecode
        global set_sha256
        global set_responsecode
        global set_serverbkdir
        global set_localbkdir
        global set_dnsfile
        global set_syncmode
        global set_addrfromdns
        global set_serverbkdir2
        global set_localbkdir2

        strpathfile=""
        if(os.name=="nt"):
            strpathfile=sys.path[0]+"\\"+set_configfile
        else:
            strpathfile="./"+set_configfile

        cf=configparser.ConfigParser()        
        if(_debugmode):
            print(strpathfile)       
        try:
            #cf.read(set_configfile,encoding="utf-8")
            #由于windows 纪事本保存为utf-8格式时默认是带utf8 bom头的
            if(bsig):
                #需要utf8 bom 这是windows 纪事本的方式
                cf.read(strpathfile,encoding="utf-8-sig")
            else:
                #这是linux等下的格式 不带utf8 bom头
                cf.read(strpathfile,encoding="utf-8")    
        except IOError as e:
            if(_debugmode):
                print("Failed to load config file")
            return False            
        except :
            if(_debugmode):
                print("Unknwon error to load config file")
            return False
        #现在保证已经正常打开配置文件 那么尝试读取吧
        str1=""
        if(_debugmode):
            print("Success open config file ")
        try:
            str1=cf.get("XFile_config","server_addr").strip()
            if(len(str1)>=1):
                set_serveraddr=str1
            else:
                return False   

            str1=""
            str1=cf.get("XFile_config","server_port").strip()
            if(len(str1)>=1):
                try:
                    ###万一出异常呢
                    set_serverport=int(str1)
                except:
                    set_serverport=21    
            else:
                set_serverport=21    
   
            str1=""
            str1=cf.get("XFile_config","sync_mode").strip()
            if(len(str1)>=1):
                try:
                    ###万一出异常呢
                    if(int(str1)==0):
                        set_syncmode=False
                    else:
                        set_syncmode=True    
                except:
                    set_syncmode=False    
            else:
                set_syncmode=False

            if(set_syncmode):
                print("Warning: sync mode is enabled!")   

            str1=""
            str1=cf.get("XFile_config","server_enablednsfile").strip()
            if(len(str1)>=1):
                try:
                    ###万一出异常呢
                    if(int(str1)==0):
                        set_addrfromdns=False
                    else:
                        set_addrfromdns=True    
                except:
                    set_addrfromdns=False    
            else:
                set_addrfromdns=False         

            str1=""
            str1=cf.get("XFile_config","server_dnsfile").strip()   
            if(len(str1)>0):
                set_dnsfile=str1
                if(_debugmode):
                    print("Found dns file : "+set_dnsfile)
                
            str1=""
            str1=cf.get("XFile_config","server_bkdir").strip()   
            if(len(str1)>0):
                set_serverbkdir=str1

            #读第二个备份目录 普通人一个机器上备份两个目录够了吧
            str1=""
            str1=cf.get("XFile_config","server_bkdir2").strip()   
            if(len(str1)>0):
                set_serverbkdir2=str1    


            str1=""
            str1=cf.get("XFile_config","local_bkdir").strip()   
            if(len(str1)>0):
                set_localbkdir=str1
            else:
                #如果没有设置本地需要备份的第一个目录 那么就直接失败了
                print("Fatal error: local backup dir is null")  
                self.FuncExit()  

            str1=""
            str1=cf.get("XFile_config","local_bkdir2").strip()   
            if(len(str1)>0):
                set_localbkdir2=str1
            else:
                #如果没有设置本地需要备份的目录2 那么直接跳过
                set_localbkdir2=""
                      

      

            str1=""
            str1=cf.get("XFile_config","server_respcode").strip()
            if(len(str1)>=1):
                set_responsecode=str1
            else:
                set_responsecode=""      

            str1=""
            str1=cf.get("XFile_config","server_username").strip()
            if(len(str1)>=1):
                #判断是否包含.back 因为必须要采用备份模式登录进去 常规模式不支持上传
                str22=str1
                str22=str22.lower( )
                if(len(str22)<=5):
                    str1+=".BACK"
                else:
                    if(str22[(len(str22)-5):].find(".back")<0):
                        str1+=".BACK"    
                set_username=str1	
            else:
                return False  


            str1=""
            str1=cf.get("XFile_config","server_password").strip()
            if(len(str1)>=1):
                set_password=str1
            else:
                return False  
                
            if(cf.get("XFile_config","server_ssl").strip( )=='1'):
                set_tls=True
            else:
                set_tls=False    
            #这只是为了保持和python版xftp参数兼容    
 
            #配置文件读取完成 

        except 	(configparser.MissingSectionHeaderError,
                configparser.NoSectionError,
                configparser.NoOptionError) as e:
                if(_debugmode):
                    print("Read string section error")	
                    print(e.message)
                return	False
        except :
            if(_debugmode):
                print("Read string section unknown error")
                return	False
        return True	

    def FuncLoadDnsFile(self)->bool:
        #尝试从独立的dns文件读取服务器地址 通常是ipv6地址
        # 格式 2xx 服务器地址
        #      5xx 错误原因
        # 这是xfiledns产生的结果 采用ftp 响应格式
        global set_dnsfile
        global _debugmode
        global set_serveraddr
        global set_addrfromdns
        if(set_addrfromdns==False):
            return False
        strfile2=""
        #如果没有配置dns文件里读取 那么就尝试直接执行xfiledns 程序来获取
        if(len(set_dnsfile)<=0):
            if(_debugmode):
                print("Call dns by execute xfiledns")
            strfile2=self.FuncExecxfiledns()    
            if(len(strfile2)<=0):
                return False
            return True    
        if(os.name=="nt"):
            strfile2=sys.path[0]+"\\"+set_dnsfile
        else:
            strfile2="./"+set_dnsfile
        sline=""    
        #尝试打开文件并读取最后几行
        if(_debugmode):
            print("Dns file= "+ strfile2)
        istart=0
        iend=0
        arr1=[]
        with open(strfile2,"r") as f1:
            try:
                arr1=f1.readlines( )
                #鬼才知道这货会不会来个惊喜,还是用个try吧
            except:
                return False    

            if(_debugmode):
                print(arr1)
            if(len(arr1)<=0):
                if(_debugmode):
                    print("dns file list is zero")
                return False
            iend=len(arr1)
            if(iend>10):
                istart=iend-5 
            #只分析最后5行 
            if(_debugmode):
                print("Dns start pos=" + str(istart))
                print("Dns end pos=" + str(iend)) 
            while istart<iend :
                if(len(arr1[istart])<10 or len(arr1[istart])>65):
                    istart+=1
                    continue
                if(arr1[istart].find('.')<0 and arr1[istart].find(':')<0):
                    istart+=1
                    continue
                sline=arr1[istart].strip( )
                istart+=1
                continue      
            #分析出最后一行可能是有效地址的行    
            if(_debugmode):
                print("Last line in dns file is: " + sline)
                print(sline)
            if(len(sline)<10):
                print("Failed to get addr from dns file")
                return False    
            if(sline!=None):
                sarr=sline.strip( ).split( )
                if(len(sarr)>=2):
                    #执行判断
                    if(len(sarr[0])!=3):
                        print("Unknown type of dns result")
                        return False
                    if(sarr[0].isdigit()==False):
                        print("Bad head of dns result")
                        return False  
                    icode1=500    
                    try:
                        icode1=int(sarr[0]) 
                    except:
                        icode1=500         
                    if(icode1<200 or icode1>=300):
                        print("Error: 5xx response of dnsfile , skipped!!!")
                        return False
                    straddr=sarr[1].strip( )
                    if(_debugmode):
                        print("Dns result: "+ straddr)
                    #判断这个字符串是否是合法的地址 只是简单的判断
                    if(len(straddr)<=0):
                        print("Error: dns addr failed for none")
                        return False
                    if(straddr.find('.')<0 and straddr.find(':')<0):
                        print("Error: bad style of dns address")
                        return False 
                    if(len(sarr)!=2):
                        print("Error: dns address error ")
                        return False
                    #否则就认为是正确的
                    print("====> Dns server addr="+straddr)
                    set_serveraddr=straddr
                    return True        

                else:
                    if(_debugmode):
                        print("Error: split dns file error")    

        return False                	

    #定义我们的退出函数 这样让用户有时间可以查看结果
    def FuncExit(self):
        #就是单纯的退出
        global _debugmode
        str1=input("Press enter key to exit......") 
        if(_debugmode):
            print(str1)
        exit( )       


    #2.75或者之后的版本支持 生成发服务器反向验证码的散列字符串 （账户反馈码散列）
    def FuncMakeAcctResponseStr(self,srandom64:str,suserran64:str="0")->str:
        #注意 这个功能只有在服务器版本大于等于2.75的版本才支持 之前版本会失败
        #如果只是简单的播放功能 不需要调用这个去强化确认服务器 因为没有必要 用个全局的明文握手码就足够了
        #请注意 在此前 必须设置一个随机64位 16进制随机数 字符串,用于反旁路蜜罐
        #注意 如果服务器端的对应账户没有设置反向验证码，但是客户端用户设置了，那么会失败
        global set_responsecode
        global _debugmode
        
        if(len(set_responsecode)<=0):
            return "0"
            #如果没有设置账户 那么直接返回只包含1个0的字符串
        #srandom64是服务器端设置的64位随机数字 16进制小写 而suerran64 则是保留给将来使用 用户端可以设置 目前默认是0
        str1=""
        str1+=set_responsecode
        str1+="_M_x_"
        str1+=srandom64.lower()
        str1+=suserran64
        if(_debugmode):
            print(str1)
        #计算第一个sha256
        md256 = hashlib.sha256()
        md256.update(str1.encode(encoding='utf-8'))
        str2 = md256.hexdigest( ).lower()
        if(_debugmode):
            print(str2)
        #执行去位替换操作 防止表攻击    
        str1="W-"
        str1+=str2[2:]
        if(_debugmode):
            print(str1)
        str1+="_"    
        str1+=srandom64.lower()
        if(_debugmode):
            print(str1)
        #再次计算sha256
        md257 = hashlib.sha256()
        md257.update(str1.encode(encoding='utf-8'))
        str2 = md257.hexdigest( ).lower()
        #只取前50位
        str1=str2[0:50]
        return str1
              





    def FuncCheckRespcode(self)->bool:
        global _serverrespcode
        global _debugmode
        global _clientrandom64
        if(len(_serverrespcode)<=0):
            return True
        if(len(_serverrespcode)>=1):
                #如果用户确实设置了反向验证码（账户反馈码） 那么就应该进行强制确认
                #但是请注意 这个功能一般只建议在公网动态ip建立的家庭服务器中启用 
                #用于确认该服务器确实是我们想要备份的目标服务器
                #可以有效干掉可能发生的蜜罐服务器, 如果是在内部网络 则不需要开启这个功能

                str001=self.FuncSendRawCmd2("RSPC",_clientrandom64)

                if(_debugmode):
                    print(str001)
                
                if(len(str001)>4):
                     str001=str001[4:]
                else:
                    str001=""
                if(len(str001)<len(_serverrespcode)):
                    print("Fatal error: server verify failed 1:")
                    return False
                else:
                    #否则 检测字符串
                    if(str001.find(_serverrespcode)<0):
                        #没有匹配到服务器反向验证码(账户反馈码)
                        print("Fatal error: server verify failed 2")
                        return False  
        return True                  



    def FuncGetRandomCode(self)->bool:
        global _ftp
        global _ftps
        global _srandomcode
        global set_tls
        global set_username
        global set_password
        global _debugmode
        global _ssha256pass
        global _serverrespcode
        global set_responsecode
        global _clientrandom64
        #2020.10 重新制作本函数 抛弃原来的md5模式 转用sha256加盐口令支持
        #必须事先生成一个16进制随机数字字符串
        self.FuncMakeAcctRandom64()

        str5 = ""
        str3 = ""
        str4 = ""
        strsha256 = ""
        md256 = hashlib.sha256()
        md256.update((set_password.strip()+"www.phoenixp2p.com").encode(encoding='utf-8'))
        strsha256 = md256.hexdigest( ).lower()
        try:
            if(set_tls):
                str5 = _ftps.sendcmd("MKEY")
            else:
                str5 = _ftp.sendcmd("MKEY")
        except (socket.error, socket.gaierror):
            return False
                 
        except ftplib.error_perm:
            if(_debugmode):
                print("Error: server do not support MKEY")
            return False
        except:
            return False
        #######################################################
        if(_debugmode):
            print("Success get mkey response=" + str5)
        #新版本采用的是二次加盐的sha256加密口令，注意检测服务器版本不可以小于231
        # 之前的代码之所以不删除 只是为了保留一段时间的兼容性 后期将禁用md5口令 将来可能会升级为sm3等    
        #mkey 指令的格式 200/211 32位随机数 64位登录时间 下标编号 是否启用sha256账户 64位随机数字 | 服务器版本
        # 我们需要提取的是 32位随机数 是否启用sha256账户 64位随机数 以及服务器版本
        # 首先检查服务器版本是否大于等于231
        arr88 = []
        str4 = str5.strip('\r')
        str4 = str4.strip('\n')
        arr88 = str4.split('|')
        if(len(arr88)<2):
            if(_debugmode):
                print("Error: bad response of mkey")
            return False
        if(_debugmode):
            print("length=" + str(len(arr88)))
        #跳转服务要求服务器版本最低是2.65
        if(int(arr88[1])<265):
            if(_debugmode):
                print("Error, server version must not below 265")
            return False
        #这里加入限制 如果用户设置了账户反馈码 那么要求的版本最低是271
        if(int(arr88[1])<271 and len(set_responsecode)>=1):
            if(_debugmode):
                print("Error, server version must not below 271")
            return False    

        if(_debugmode):
            print("version=" + arr88[1])    
        #现在保证了服务器版本满足 那么对arr88[0]进行分解
        arr8 = []
        arr8 = arr88[0].strip().split(' ')
        if(_debugmode):
            print("len of arr88=" + str(len(arr88)))
        if(len(arr8)<6):
            print("Split mkey response 1 failed")
            return False
        #现在至少在条目数量上满足格式
        #我们需要提取的是  arr8[1] : 32位随机数字
        #                 arr8[4] : 是否启用sha256加密账户
        #                 arr8[5] : 64位随机数字

        if(len(set_responsecode)>=1):
            #生成反馈码加密 sha256 30位
            _serverrespcode=self.FuncMakeAcctResponseStr(arr8[5].strip(),_clientrandom64)
            if(_debugmode):
                print("Our rasp string ="+_serverrespcode)
            #但是必须注意 这个反馈码必须是在登录成功后才能获取,在登录前,目前建议使用握手码来防止蜜罐服务器或者登录到错误服务器    
            
                    



        #这里开始计算口令
        if(int(arr8[4])==0):
            str3 = "$+K8"
            str3 += arr8[1].strip().upper()
            str4 = set_password.strip( )
            #进行清理 防止发生问题
            str3 += str4.strip()
            str3 += arr8[5].strip().lower()
            #完成第一次加盐操作
        else:
            str3 = "$+K8"
            str3 += arr8[1].strip().upper()
            str3 += strsha256
            #要求使用加密的账户
            str3 += arr8[5].strip().lower()
        #完成第一次sha256加密的原始字符串的组合 
        if(_debugmode):
            print(str3)                     
        sha256 = hashlib.sha256()
        sha256.update(str3.encode(encoding='utf-8'))
        str3 = sha256.hexdigest().lower()
        if(_debugmode):
            print("First sha256=" + str3)
        #现在再次执行sha256加密 
        str3 += arr8[5].strip().upper()
        str3 += "#"
        str3 += arr8[1].strip().lower()
        if(_debugmode):
            print("Next sha256 raw str=" + str3)

        #完成第二次sha256加密的原始字符串组合
        # 现在执行最终的计算
        sha256 = hashlib.sha256()
        sha256.update(str3.encode(encoding='utf-8'))
        str4 = sha256.hexdigest().lower()
        if(_debugmode):
            print("last sha256=" + str4)
        #最后需要去掉前面两位 并进行替换
        str3 = "=_"
        str3 += str4[2:]
        _ssha256pass = str3
        #拷贝到全局口令
        #最后的口令制作完成
        if(_debugmode):
            print("Login password of sha256:"+str3)
        
        _srandomcode = arr8[1].strip()
        return True

    #检查握手码
    def CheckShakeCode(self , str8:str)->bool :
        global set_shakecode
        if(set_shakecode==0):
            return True
        #否则 对str8 进行分解  str8其实就是服务器欢迎语句
        arr8=str8.split("|")
        if(len(arr8)!=2):
            print("Failed to find shakecode 1")
            return False
        str7=arr8[1]
        if(len(str7)<=0 or len(str7)>16):
            return False
        #将数字转换成16进制 然后比较字符串是否相同
        try:
            #尝试转换
            if(int(str7,16)==set_shakecode):
                #可能出异常
                return True
        except:
            return False        
        return False

    #返回True 如果成功 这个函数还附带了对用户设置的远程目录的清理动作,应该在执行同步操作前执行   
    def FuncMakefullDir(self,bmain:bool=True)->bool:
        global _ftp
        global _ftps
        global set_tls
        global set_serverbkdir
        global set_serverbkdir2
        global _debugmode

        
        #首先分解远程服务器目录
        strdir=""
        if(bmain):
            strdir=set_serverbkdir
        else:
            strdir=set_serverbkdir2    

        arr1=[]
        arr1=strdir.strip().split('/')
        if(_debugmode):
            print(arr1)

        str111=""
        for str222 in arr1:
            #重新组合成正确的远程目录
            if(len(str222)>0):
                str111+="/"
                str111+=str222
        if(len(str111)<=0):
            str111="/"
        if(_debugmode):
            print(str111)
        #重新设置远程备份目录
        if(bmain):
            #
            set_serverbkdir=str111  
            strdir=set_serverbkdir
        else:
            set_serverbkdir2=str111     
            strdir=set_serverbkdir2 
        #然后转入常规执行
        if(len(strdir)<=1):
            print("Remote dir not ok: " + strdir)
            return False 
                   
                

        if(self.FuncChangeCWD(strdir)):
            if(_debugmode):
                print("FuncMakefulldir succ[already exist]:" + strdir)
            return True

        if(len(arr1)<=0):
            return True
            #可能是直接放到根目录下了 那就不需要操作
        #否则  需要分段尝试
        if(self.FuncChangeCWD("/")==False):
            if(_debugmode):
                print("Failed to change to / in make full dir")
            return False
        sname1=""
        slastdir=""    
        for sname1 in arr1 :
            #分段进行
            if(_debugmode):
                print(sname1)
            if(len(sname1)<=0):
                #因为用/开头 分解的时候可能出现空项目
                continue    
            str1=slastdir
            str1+="/"
            str1+=sname1
            if(_debugmode):
                print(str1)
            if(self.FuncChangeCWD(str1)):
                slastdir=str1
                continue
            else:
                if(_debugmode):
                    print("Need to make sub dir:" + sname1)
                if(self.FuncMakeSingleDir(sname1)==False):
                    print("Failed to make sub dir:" + sname1)
                    return False
                if(self.FuncChangeCWD(str1)==False):
                    print("Failed to change dir "+str1)
                    return False
                else:
                    slastdir=str1
                    continue
        #所有操作执行完成
        if(_debugmode):
            print("Success make full dir")
        return True                



                  	

    def ConnectToServer( self)->bool:
        global _mbcon
        global _ftp
        global _ftps
        global _debugmode
        global _srandomcode
        global _ssha256pass
        global set_serveraddr
        global set_username
        global set_password
        global set_serverport
        global set_sha256
        global set_shakecode
        global set_tls
        global _serverrespcode
        global set_responsecode
        str7=""


        if(_mbcon):
            #load player file again
            #self.FuncLoadConfigFile()
            #connect the server
            if(_debugmode):
                print(set_serveraddr)
                print(set_username)
                print(set_password)
                print("portnum="+str(set_serverport))
            if(set_tls):
                if(_debugmode):
                    print("Now will in TLS-SSL connection mode")
                _mbssl=True
                _ftps.encoding='utf-8'
                
            else:
                if(_debugmode):
                    print("Now will in Standard connection mode")
                _mbssl=False
                _ftp.encoding='utf-8'
                      
                    
            if(len(set_serveraddr)<=0 or len(set_username)<=0 or len(set_password)<=0 or set_serverport<=0 or set_serverport>=65535):
                print("550 bad para")
                return False
            else:
                str7=""
                strrealaddr=set_serveraddr

                if(set_tls):
                    try:
                        str7=_ftps.connect(host=strrealaddr,port=set_serverport)
                        #str7=_ftps.connect(host=strrealaddr,port=set_serverport,timeout=45)
                        if(str7==None):
                            print("Failed to connect server in tls mode")
                            return False
                        _ftps.set_pasv(True)    
                        if(self.CheckShakeCode(str7)==False):
                            print("Check shake code failed")
                            return False
                        
                    except (socket.error, socket.gaierror):
                        print("550 connect failed")
                        return False
                    except:
                        print("550 login failed")
                        return False
                    if(_debugmode):
                        print(str7)	
                    
                    if(self.FuncGetRandomCode()==False):
                        if(_debugmode):
                            print("Failed to get random code")                 
                        return False
                    
                    #这里添加转换 因为明文不安全 这里转换成sha256模式的口令
                    # 注意 这是XFile服务器才支持的格式 普通FTP服务器是不支持的

                    strpassword = _ssha256pass
                    if(_debugmode):
                        print("username=" + set_username)
                        print("password=" + strpassword)
                    try:
                        _ftps.login(set_username,strpassword)
                    except ftplib.error_perm:
                        _ftps.close()
                        print("550 connect failed 2")
                        return False
                    except:
                        _ftps.close( )
                        print("550 login failed 2")

                        return False
                    #现在可以保证已经登录到服务器了 
                    #乱用SSL会导致性能问题
                    #注意上面不能用quit 因为quit遇到特殊的服务器回答 会引发投递异常
                        

                else:
                    try:
                        str7=_ftp.connect(host=strrealaddr,port=set_serverport)
                        #这个timeout有问题 ftplib 如果设置为45 有时候会卡
                        #str7=_ftp.connect(host=strrealaddr,port=set_serverport,timeout=45)
                        if(str7==None):
                            print("Failed to connect server")
                            return False
                        _ftp.set_pasv(True)    
                        if(self.CheckShakeCode(str7)==False):
                            print("Check shake code failed")
                            return False
                        
                    except (socket.error, socket.gaierror):
                        _ftp.close()
                        print("550 connect failed")
                        return False
                    except:
                        _ftp.close()
                        print("550 login failed")
                        return	False
                    if(_debugmode):
                        print(str7)	
                    if(self.FuncGetRandomCode()==False):
                        if(_debugmode):
                            print("Error to get randome code 2")
                        return False
                    strpassword = _ssha256pass
                    if(_debugmode):
                        print("username=" + set_username)
                        print("password=" + strpassword)
                    try:
                        _ftp.login(set_username,strpassword)
                    except ftplib.error_perm:
                        _ftp.close()
                        print("550 connect failed 2")
                        return False
                    except:
                        _ftp.close( )
                        print("550 login failed 2")

                        return False
                    #现在可以保证已经登录到服务器了 
                    #乱用SSL会导致性能问题
                    #注意上面不能用quit 因为quit遇到特殊的服务器回答 会引发投递异常    
            #操作成功了 后续单独获取服务器地址            	
            _mbcon=False            
            return True            
                    



            
			
        else:
            if(set_tls):
                try:
                    _ftps.close( )
                except (socket.error, socket.gaierror):
                    pass
                except:
                    pass
            else:
                try:
                    _ftp.close( )
                except (socket.error, socket.gaierror):
                    pass
                except:
                    pass	

            _mbcon=True
            return True
   


		

    


    def FuncDisconnect(self):
        #中断连接
        global _ftp
        global _ftps
        global _mbcon
        global set_tls
        if(_mbcon):
            return
        if(set_tls):
            try:
                _ftps.close( )
            except:
                pass
        else:
            try:
                _ftp.close( )
            except:
                pass
        _mbcon=True

    #从Ftp的回答里提取应答数字 如果为空 则返回550
    def FuncGetNumFromResponse(self,sresponse:str)->int:
        global _debugmode
        if(sresponse==None):
            return 550
        if(len(sresponse)<3):
            return 550
        icode=0  
        try:
            icode=int(sresponse[0:3])
        except:
            icode=550
        return icode        



    #这个函数携带参数,返回的是服务器实际应答 如果失败 返回空字符串
    def FuncSendRawCmd2(self,scmd:str,spara:str)->str:
        global _mbcon
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        str5=""
        if(_debugmode):
            print("Send raw command2 function is called")
        if(len(scmd)<=0):
            scmd="NOOP"
        if(len(spara)>0):
            scmd+=" "
            scmd+=spara    
        try:
            if(set_tls):
                str5=_ftps.sendcmd(scmd)                	
            else:
                str5=_ftp.sendcmd(scmd)
        except  (socket.error, socket.gaierror):
            return ""
        except ftplib.error_perm:
            return str5	
        except ftplib.error_temp:
            return str5
        except ftplib.error_reply:
            return str5        	 
        except :
            return str5
        return str5	

    #这个函数不带参数,返回的是字符串 如果失败 返回的长度为0 否则返回服务器实际返回的应答
    def FuncSendRawCmd(self,scmd:str)->str:
        global _mbcon
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        str5=""
        if(_debugmode):
            print("FuncSendRawCmd is called")
        if(len(scmd)<=0):
            scmd="NOOP"
        try:
            if(set_tls):
                str5=_ftps.sendcmd(scmd)	
            else:
                str5=_ftp.sendcmd(scmd)
        except  (socket.error, socket.gaierror):
            return ""
        except ftplib.error_perm:
            return str5	
        except ftplib.error_temp:
            return str5
        except ftplib.error_reply:
            return str5    	 
        except :
            return str5
        return str5	

    #单独编写这个函数 是因为XFile不支持标准ftp的改名指令 而是采用独立的一条
    def FuncRenameFile(self,soldname:str,snewname:str)->str:
        global _debugmode
        str1=soldname.strip()
        str1+="|"
        str1+=snewname.strip()
        return self.FuncSendRawCmd2("RNAM",str1)    

    #这个函数用来获取当前目录下的文件和目录 XFile专用格式
    def FuncListDir(self,sdir:str)->list:
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        global _mbcon
        data=[]
        #下面这个调用不可以忽略 万一是tls呢
        self.FuncSetProt_P( )
        ##下面执行正式操作
        if(_debugmode):
            print("FuncListDir is called")
        if(set_tls):
            try:
                _ftps.retrlines('LIST',data.append)
            except (socket.error, socket.gaierror):
                return data
            except ftplib.error_perm:
                return data
            except ftplib.error_temp:
                return data    
            except:
                if(_debugmode):
                    print("Error to get dir list tls mode")
                return data
        else:
            try:
                _ftp.retrlines('LIST',data.append)
            except (socket.error, socket.gaierror):
                return data
            except ftplib.error_perm:
                return data
            except ftplib.error_temp:
                return data    
            except:
                if(_debugmode):
                    print("Error to get dir list raw text mode")
                return data
        #现在可以保证已经成功获取了文件和目录列表
        # filesize 1/0 modtime |filename or dirname
        # filesize=64bit long int
        if(_debugmode):
            print("Success get list from server")
            print(data)
        return data

    #由于XFile 服务器默认是明文传输 如果要全部采用tls 则每次数据端口连接前必须调用 prot_p 命令 但是请注意 python ftplib 有个致命的bug, 至少在2021年还没有修复 就是上传传输结束后会死等待ssl数据导致超时 所以这里强制关闭了数据传输的ssl
    def FuncSetProt_P(self,bprivate:bool=False)->bool:
        global _debugmode
        global _ftps
        global set_tls
        ####忠告 Python 3.7 3.8 版本的ftp lib 的stor调用ssl存在数据传输接受后继续等待的问题 这个问题已经被提出，但是目前并没有被修复 这是python ftplib 本身实现的错误
        #### 因此这里默认关闭数据传输的SSL 这是python ftplib 本身代码调用ssl存在问题 不是服务器的问题 修复方法要在python ftplib 的 的storbinary等函数的结束，强行关闭ssl 还是等待官方的修复吧
        if(set_tls==False):
            return 
        str1=""    
        try:
            if(bprivate):
                str1=_ftps.prot_p( ) 
            else:
                str1=_ftps.prot_c( )
        except:
            print("Unknown exception in set prot_p")
            self.FuncExit( )
        if(_debugmode):
            print("Prot_operate return: "+str1)    
        return True           

    #使用这个函数来下载文件sfilename 是文件名 不包目录 spath是本地目录 mftpdir 是远程目录 ftp必须已经切换到当前目录
    def FuncDownloadFile(self,spath:str,sfilename:str)->int:
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        global _bcomparemodtime
        if(_debugmode):
            print("FuncDownloadFile is called :" + sfilename)
        #先尝试读取本地文件的长度和最后修改时间
        bexist=False
        #bneeddownload=True
        str01=""
        str02=""
        ifilesize=-1
        ifilemodtime=0
        localfilesize=-1
        localfilemodtime=0
        if(os.name=="nt"):
            str01=spath
            str01+="\\"
            str01+=sfilename
            str01.replace("/","\\")
            str01.replace("\\\\","\\")
        else:
            str01=spath
            str01+="/"
            str01+=sfilename
            str01.replace("//","/")   
        if(_debugmode):
            print("Local download filename=" + str01)
        #现在尝试获取本地文件属性 如果文件存在的话
        try:
            localfilemodtime=int(os.stat(str01).st_mtime)
            localfilesize=int(os.stat(str01).st_size)
            
            
                
        except FileNotFoundError: 
            if(_debugmode):
                print(" File not found :" + str01)
            pass
        except:
            print("Unknown exception in Funcdownload function :" + str01)
            pass   
        
        if(True): 
            #无论本地文件是否存在 都应该通过获取远程文件的最后修改时间 来完成最后的操作
            str02=self.FuncSendRawCmd2("SIZT",sfilename).strip()
            if(len(str02)<=4):
                if(_debugmode):
                    print("Error response from server, file may nost exist")
                print("------>Error , file not exist in server, will skip :"+str01)
                return 0    
            elif(int(str02[0:3])>=300 or int(str02[0:3])<200):
                # 远程文件不存在 
                if(_debugmode):
                    print("Error response from server, need download")
                print("------>Error , file not found in server, will skip :"+str01)
                return 0    
            else:
                #否则         
                x01=str02.strip( ).split(' ')
                if(len(x01)>=4):
                    try:
                        ifilemodtime=int(x01[3])
                        ifilesize=int(x01[1])
                        if(_debugmode):
                            print("Local file size= " +str(localfilesize) + " and time= " + str(localfilemodtime))
                            print("Remote file size="+str(ifilesize) + " and time=" + str(ifilemodtime))
                        if((ifilemodtime==localfilemodtime or _bcomparemodtime==False) and ifilesize==localfilesize):
                            print("****** Found file already exist , skip download :"+str01)
                            return 0
                    except:
                        print("------>Error ,unknown except to get remote file size and time, will skip:"+str01)
                        return 0
        #剩下的 就是需要下载了 必须发送下面的指令 当前关闭ssl private 模式 
        print("-> Start new download: " +str01)
        self.FuncSetProt_P( )
        try:
            with open(str01,"wb") as f1:
                str02="RETR "+sfilename
                #下载指令
                if(set_tls):
                    _ftps.retrbinary(str02,f1.write)
                else:
                    _ftp.retrbinary(str02,f1.write)          
        except ftplib.error_perm:
            print("Download transfer 5xx error: ")
            return 0
        except ftplib.error_temp:
            print("Download transfer 4xx error: ")
            return 0
        except OSError :
            print("Download transfer error :failed to open file or SSL connect timeout :" + str01)
            
            return 0
        except IOError :
            print("Download transfererror socket error: " + str01)
            return 0    
        except:
            print("Download transfererror unknown: "+str01)
            return 0  
        
        ##否则 就是下载成功了 那么修改最后修改时间吧 注意是utc时间
        print("File download success :" + str01)
        try:
            if(ifilemodtime>0):
                os.utime(str01,(ifilemodtime,ifilemodtime))
        except:
            #因为有些系统可能不支持这个操作
            if(_debugmode):
                print("Error: failed to set local file time: " + str01 )
            pass     
     
        return 1           
                    
                            
            
    #使用这个函数来上传文件 spathfile是本地路径文件 sfilename 是上传的文件名 注意啊 必须已经切换到要上传的目录 因为XFile为了安全考虑,拒绝采用全路径的直接上传 返回0 失败 返回1 成功
    def FuncUploadFile(self,sfilename:str,spathfile:str)->int:
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        global _mbcon
        global _bcomparemodtime
        if(_debugmode):
            print("FuncUploadFile is called " + sfilename)
        
        #str1=spathfile
           
        # 这里注意下 必须使用二进制方式进行文件上传 XFile 不管文件格式 只接受二进制流传输 而且注意： 必须已经切换到服务器端当前目录下 STOR指令不可以包含路径！！！ 
        # 这里再次执行SIZT指令 来确认服务器上不存在同样长度和最后修改时间的文件 成功返回 2xx 文件长度 文件创建时间 文件修改时间
        # 注意 sizt 返回的时间是时间
        # SIZT指令是XFile 专用指令 同时返回文件长度和最后修改时间 这样可以快速跳过已经存在的相同文件 
        # 因为和常见的nas硬件软件操作系统一体化不同,XFile单纯是个软件,支持了太多的操作系统,包括windows linux 等,各种文件系统有不同特性,无法象nas那样锁定文件格式
        # 因此稍微耗费点时间做二次检查,是值得的
        #
        # 和各位在网上看到的上传文件操作不同，我们的上传操作 
        # 1 检查服务器上是否已经存在同名文件(sizt) 条件是最后修改时间和文件长度相同 如果相同 则跳过上传操作
        # 2 如果不存在 则上传本地文件到服务器端
        # 3 上传成功后 调用SETT 指令修改文件的最后修改时间
        # SETT 指令格式是 SETT 文件创建时间 文件修改时间 *文件名
        # 注意是utc时间 如果不需要修改 则将该时间设置为0 就可以 没有特殊说明默认10进制
        str01=""
        
        bexist=False
        ifilesize=0
        ifilemodtime=0
        localimodtime=0
        try:
            localimodtime=int(os.stat(spathfile).st_mtime)
        except FileNotFoundError: 
            return 0
        except:
            return 0    
        if(_debugmode):
            #       
            print("Local utc time = " + str(localimodtime))
        

        
        if(_debugmode):
            print("local modify time=" + str(localimodtime))
        try:
            #必须进行保护    
            localifilesize=os.stat(spathfile).st_size
        except FileNotFoundError:
            return 0
        except :
            return 0        
        if(_debugmode):
            print("local file size=" + str(localifilesize))
        str01=self.FuncSendRawCmd2("SIZT",sfilename).strip()

        if(_debugmode):
            print("Response of size command is: ")
            print(str01)
        if(len(str01)<4):
            if(_debugmode):
                print(sfilename + " need normal upload")
        #否则 尝试进行分解吧
        elif(int(str01[0:3])>=300 or int(str01[0:3])<200):
            if(_debugmode):
                print("Error response from server, need upload")
        else:
            #现在进行提取吧
            x01=str01.strip( ).split(' ')
            if(len(x01)>=4):
                #现在已经成功被分解
                try:
                    ifilesize=int(x01[1])
                    
                    ifilemodtime=int(x01[3])
                    bexist=True
                    if(_debugmode):
                        print("Remote file size=" + str(ifilesize))
                        print("Remote file mod time= "+ str(ifilemodtime))
                    
                except:
                    if(_debugmode):
                        print("Except found in split of response to int")
                       
            else:
                #分解失败
                if(_debugmode):
                    print("Split response failed , need upload")  
        if(_debugmode):
            print("Remote filesize (last)=" + str(ifilesize) )    
            print("Remote file modify time(last)=" + str(ifilemodtime)) 
            print("Local filesize= " + str(localifilesize)  )
            print("Local file mod time= " + str(localimodtime))        
        #现在进行判断
        if(bexist):
            print("Found file exist , now to check if same --->")
            #如果成功获取了服务器上同名文件的长度和最后修改时间 那么如果相同 我们将默认跳过 
            #如果设置忽略最后修改时间 那么这里将不比较最后修改时间
            if(localifilesize==ifilesize and (ifilemodtime==localimodtime or _bcomparemodtime==False)):
                print("****** Found file already exist in server, will skip " + sfilename)
                return 1
        #好了 现在执行上传操作 注意 只能使用二进制上传 XFile 不支持type a
        print("-> Start new upload: " +spathfile)
        self.FuncSetProt_P( )
        #上面这个函数不可以忽略
        f1=None
        str02=""
        try:
            with open(spathfile,"rb") as f1:
                #具体上传
                str01="STOR "+sfilename
                if(set_tls):
                    _ftps.storbinary(str01,f1)
                else:
                    _ftp.storbinary(str01,f1)  
                #if(f1 in locals and f1):
                #f1.close()    
        except ftplib.error_perm:
            print("Upload transfer 5xx error: ")
            return 0
        except ftplib.error_temp:
            print("Upload transfer 4xx error: ")
            return 0
        except OSError :
            print("Upload transfer error :failed to open file or SSL connect timeout :" + spathfile)
            
            return 0
        except IOError :
            print("Upload transfererror socket error: " + spathfile)
            return 0    
        except:
            print("Upload transfererror unknown: "+spathfile)
            return 0    
        #finally:
        #   if(f1 in locals()):
        #        f1.close()
        #现在上传操作完成
 
        if(True):
            print("Upload transfer success :"+sfilename)      
        #现在使用扩展指令重新设置最后修改时间
        #指令格式 SETT 64位文件创建时间 64位文件修改时间 *文件名
        str02="0 " + str(localimodtime)+" *"+sfilename
        
        if(_debugmode):
            print("SETT parameters =")
            print(str02)
        str01=self.FuncSendRawCmd2("SETT",str02)
        if(_debugmode):
            print(str01)
        if(len(str01)<3):
            print("Unknown error in sett command :"+sfilename)
            return 0
            #因为这可能只是设置失败 
            #对于那种特别重要的文件 可以使用指令 F256 文件名来获取服务器端的sha256文件散列 但是注意 本地文件散列计算必须在上传操作前完成，因为缓冲的存在 如果是内存出现错，是校验不出来的
            #由于F256 计算文件散列操作非常耗时间和服务器资源，你必须调整指令超时时间，否则如果是大文件，会因为本地指令等待响应超时而导致失败
        if(_debugmode):
            print(str01)
        #到这里 整个文件的上传操作才算完成 
        return 1     

    #单独设置一个切换目录的函数 这样方便调用
    def FuncChangeCWD(self,snewcwd:str)->bool:
        #snewcwd为期望的工作目录 可能不存在 那么s将返回False 否则返回True
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        str02=""
        try:
            if(set_tls):
                str02=_ftps.cwd(snewcwd)
            else:

                str02=_ftp.cwd(snewcwd)
        except (socket.error, socket.gaierror): 
            print("Error of FuncChangeCWD")
            self.FuncExit()
        except ftplib.error_perm:
            if(_debugmode):
                print(str02 + " 5xx " + snewcwd)
            return False  
        except ftplib.error_temp:
            if(_debugmode):
                print(str02 + " 4xx " + snewcwd)
            return False     
        except :
            if(_debugmode):
                print("Unknown exception in ChangeCWD fucntion")
            return False
        #是否需要分解?
        return True  

    #单独设置一个删除目录和文件的函数 这样方便调用
    def FuncDelPathfile(self,sname:str, bisfile:bool)->bool:
        #snewcwd为期望的工作目录 可能不存在 那么将返回False 否则返回True
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        str02=""
        if( bisfile==False and (sname=="." or sname=="..")):
            #过滤掉特殊目录
            return True
        try:
            if(set_tls):
                if(bisfile):
                    str02=_ftps.delete(sname)
                else:
                    str02=_ftps.rmd(sname)
                
            else:
                if(bisfile):
                    str02=_ftp.delete(sname)
                else:
                    str02=_ftp.rmd(sname)

                 
        except (socket.error, socket.gaierror): 
            print("Error of delete pathfile :" +sname)
            self.FuncExit()
        except ftplib.error_perm:
            if(_debugmode):
                print(str02 + " " + sname)
            return False  
        except ftplib.error_temp:
            return False     
        except :
            return False
        #是否需要分解?
        return True       

    #单独设置一个创建目录的函数 注意必须是当前目录下的一个子目录 不可以包含目录字符 例如当前目录 /backup 创建 subdir1下级目录 subdir1
    def FuncMakeSingleDir(self,ssubdir:str)->bool:
        #ssubdir 必须是一个不包含目录字符的单纯的子目录名 返回True 或者 False
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        if(ssubdir==None):
            return False  
        if(ssubdir==".." or ssubdir=="."):
            #不可以创建. 和 ..
            return True    
        str02=""
        try:
            if(set_tls):
                str02=_ftps.mkd(ssubdir)
            else:

                str02=_ftp.mkd(ssubdir)
        except (socket.error, socket.gaierror): 
            print("Error of FuncMakeSingleDir")
            self.FuncExit()
        except ftplib.error_perm:
            if(_debugmode):
                print(str02 + " " + ssubdir)
            return False  
        except ftplib.error_temp:
            return False     
        except :
            if(_debugmode):
                print("Unknown exception found in del dir function")
            return False
        #是否需要分解?
        return True 

    #这个函数 尝试调用外部程序xfiledns 进行服务器地址的解析 失败返回空字符串
    def FuncExecxfiledns(self,scmd:str="")->str:
        global _debugmode
        global set_serveraddr
        global set_cfgxfilednsname
        sname1=scmd.strip()
        str01=""
        #根据不同的操作系统 分别判断并处理
        sconfigfile="" 
        if(len(sname1)<=0):
            if(os.name=='nt'):
                sname1=os.getcwd( )+"\\xfiledns.exe"
                sconfigfile=os.getcwd( )+"\\" +set_cfgxfilednsname
                sconfigfile.replace("\\\\","\\")
            else:
                sname1=os.getcwd( )+"/xfiledns"  
                sconfigfile=os.getcwd( )+"/" +set_cfgxfilednsname
                sconfigfile.replace("//","/")
        if(_debugmode):
            print("Dns tool is called: "+sname1)
            print("Config file is : " +sconfigfile)
        if(os.path.isfile(sname1)==False):
            print("======>Dns tool file not exist: "+sname1)
            return str01    

        #调用subprocess 因为现在可以保证文件存在的
        #默认调用的配置文件 固定
        #sconfigfile="./"+ set_cfgxfilednsname

        try:
            str01=subprocess.check_output([sname1,sconfigfile],shell=True)
        except subprocess.CalledProcessError as e:
            print("======>xfiledns failed: "+ str(e.output) ) 
            return ""
        except OSError:
            print("======>xfiledns failed for os error")
            return ""    
        except :
            print("======>xfiledns failed in this os")
            return "" 
        ##否则就是执行成功 但是注意 解析可能失败 需要分解才知道哦 到这里只是表示xfiledns工具确实是运行了
        if(_debugmode):
            print(str01)
        
        str02=str(str01,encoding="utf-8").strip()
        print("Dns execute result=" + str02)
        if(len(str02)<4):
            return ""
        #否则 尝试分解   
        aa=str02.split( )             
        if(len(aa)<=1 or len(aa)>2):
            if(_debugmode):
                print("Dns result error 1")
            return ""
        try:
            if(int(aa[0])<200 or int(aa[0])>=300):
                if(_debugmode):
                    print("Dns result error 5")
                return ""
        except:
            return ""   
        ##否则就认为成功了
        str01=aa[1]      
        if(_debugmode):
            print("Dns right result = "+str01) 
        set_serveraddr=str01              
        ##返回结果 不要抛sb异常
        return str01.strip()    

    
    ##这个函数 是从服务器上指定目录 恢复到本地目录
    def FuncRestore(self,mlocaldir1:str,mftpdir1:str)->int:
        #注意 同步模式下,如果本地某个目录 服务器上却不存在 那么将导致本地目录被删除 所以一定要谨慎使用同步模式 但是可以用备份恢复模式
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        global _bcomparemodtime
        global _bdeletedirfilesyncmode
        # mftpdir1 是远程目录
        #mlocaldir1 是本地目录 它必须已经存在 
        mlocaldir=mlocaldir1
        mftpdir=mftpdir1
        str01=""
        bdir=False
        #这个是远程文件
        remoteobj=[]
        #这个是远程子目录
        remotedir=[]

        if(_debugmode):
            print("Restore function is called , local dir="+mlocaldir)
            print(" Ftp dir="+mftpdir)
        
        #首先尝试切换到远程目录
        if(self.FuncChangeCWD(mftpdir)==False):
            print("Failed change to work dir: " + mftpdir)
            print("Warning: " + mlocaldir + " ----Skipped")
            return 0  
        try:
            dirlist=os.listdir(mlocaldir)
            if(_debugmode):
                print(dirlist)
                print(" ")
            fdata=self.FuncListDir(mftpdir)
            if(_debugmode):
                print(fdata)
            if(len(fdata)>0):
                #那么执行分解
                for fobj in fdata:
                        if(_debugmode):
                            print(fobj)
                        #执行分解操作
                        arr2=[]
                        arr2=str(fobj).strip().split('|')
                        #arr2 现在被分解成两个部分 前面是参数 后面是文件名或者目录名
                        if(len(arr2)!=2):
                            if(_debugmode):
                                print("Split list string failed :" +str(fobj))
                            continue
                        if(arr2[1]=='.' or arr2[1]=='..'):
                            #特殊目录必须跳过
                            continue
                        arr3=arr2[0].split( )
                        if(len(arr3)!=3):
                            if(_debugmode):
                                print("Split list string failed 2 :" + arr2[0])
                            continue
                        # 现在可以保证已经分解成功了
                        # arr3[0] 文件长度 16进制
                        # arr3[1] 如果为1 是文件 为0 则是目录
                        # arr3[2] 则是文件的最后修改时间 16进制s
                        # arr2[1] 则是文件名或者目录名  
                        # 采用元组的形式进行保存 格式 文件名 0=dir 文件长度 文件最后修改时间
                        if(int(arr3[1])!=0):
                            #这是文件
                            #但是注意 我们默认是大小写敏感 如果要处理不敏感 可以将字符串改成大写或者小写 然后进行匹配
                            #但是毕竟绝大部分情况 这个代码跑的没有问题 哪怕是windows ntfs
                            if(_bcomparemodtime):
                                #如果使用最后修改时间
                                remoteobj.append((str(arr2[1]),int(arr3[1]),int(arr3[0],16),int(arr3[2],16)))
                            else:
                                #如果不使用最后修改时间
                                remoteobj.append((str(arr2[1]),int(arr3[1]),int(arr3[0],16),0))
                        else:
                            #这是目录
                            remotedir.append(str(arr2[1]))
                                    
            #end if len(fdata)>0

            ##执行次序是 如果是同步模式并且打开了删除开关 先删除本地多余子目录 然后删除本地多余文件
            ##然后再次根据远程服务器的列表 执行文件下载操作
            ##最后才是创建本地子目录 然后执行循环
            if(set_syncmode and _bdeletedirfilesyncmode and len(dirlist)>0):
                #先删除本地多余的目录和文件 警告 万一出现错误 同步模式下将导致目录本地文件被错误的删除
                #linux下注意本地文件和目录的权限  如果不是本用户目录 则会删除失败
                for s001 in dirlist:
                    #执行本地操作
                    if(s001=="." or s001==".."):
                        continue
                    #先判断是文件还是目录
                    
                    str01=os.path.join(mlocaldir,s001)
                    if(_debugmode):
                        print("Loop check : "+str01)
                    if(os.path.isdir(str01)):
                        #这是目录
                        # 按目录进行处理
                        if(remotedir.count(s001)<=0):
                            if(_debugmode):
                                print("Sync restore mode , need to del dir :" + str01)
                            #如果远程子目录中不存在这个本地目录 那么删除它
                            #这里使用count 而不使用index 主要是为了避免异常处理啊 效率差点 但是干净多了
                            try:
                                ###
                                shutil.rmtree(str01,True)
                            except:
                                pass    
                            

                    elif(os.path.isfile(str01)):
                        #这是文件 那么按文件处理
                        #需要检测这个文件是否存在
                        bfound1=False
                        for tup3 in remoteobj:
                            if(tup3[0]==s001):
                                bfound1=True
                                break
                        if(_debugmode and bfound1==False):
                            print("Sync mode , need to del file: "+str01)
                        if(bfound1==False):
                            #删除文件  
                            try:
                                ###  
                                os.remove(str01)
                            except:
                                pass    
                    else:
                        pass    
            ###到这里 同步模式删除本地文件已经结束了 接下来 我们需要首先下载文件 然后再递归处理子目录
            # 次序不可以搞错 否则需要频繁的cwd到当前目录 效率太低了

            for fobj in remoteobj:
                #先处理文件 remoteobj保存的是远程文件
                #如果文件长度和时间一致 就跳过
                ilocalftime=-1
                ilocalfsize=-1
                #fobj 是个tuple
                str01=os.path.join(mlocaldir,fobj[0])
                if(_debugmode):
                    print("Check remote : "+str01)
                if(os.path.isfile(str01)):
                    #如果文件本地已经存在
                    try:
                        ilocalftime=int(os.stat(str01).st_mtime)
                        ilocalfsize=int(os.stat(str01).st_size)  
                        if(_debugmode):
                            print("Success got local file size="+str(ilocalfsize) + "filetime="+str(ilocalftime)) 
                            print("Remote size= "+str(fobj[2]) + " and time ="+str(fobj[3]))
                        if(ilocalfsize==fobj[2] and (ilocalftime==fobj[3] or _bcomparemodtime==False) ):
                            if(_debugmode):
                                print("File already exist in local , will skip and coninue "+str01)
                            print("----> File alreay exist in local, will skip :"+str01)    
                            continue   
                    except:
                        #可能是文件正好被删除等
                        if(_debugmode):
                            print("???? Failed to get local file size and time, found except " + str01)
                        pass    
                else:
                    if(_debugmode):
                        print("File not exist in local , need to down :" +str01)    
                ## 注意这里 我们没有检测返回结果 无论是成功或者失败 都将继续下一个     
                self.FuncDownloadFile(mlocaldir,fobj[0])  
                continue  

            #到这里 独立文件下载操作完成 我们需要递归处理子目录了
            for fobj in remotedir:
                #递归调用
                #注意需要先建立本地子目录
                str01=os.path.join(mlocaldir,fobj)
                if(os.path.isdir(str01)==False):
                    if(_debugmode):
                        print("Try to make subdir " +str01)
                    try:
                        os.mkdir(str01)
                    except:
                        print("----> Error, failed to create dir :" +str01)
                        continue
                #否则 无论如何 子目录已经存在了
                str02=mftpdir
                str02+="/"
                str02+=fobj
                 

                self.FuncRestore(str01,str02)
                continue        
                        
                
                   
                             


                            

            
        except Exception  as e:
            print("------> Error : unknown exception in restore :" + mftpdir)
            return -1
        
        ########执行完成
        return 1     
         
        
        
            

    #调用这个函数 用来删除在服务器上存在 但是本地不存在的文件 只有同步模式才需要执行 一般我不建议使用同步模式 使用备份模式更安全
    #因为XFile软件本身跨平台，不像nas硬件那样和底层系统以及文件系统深度捆绑，可以有明确的属性，而我根本不知道用户用的到底是什么神仙s文件系统
    #因此比如象 可执行位 只读 隐蔽 系统 uid gid 等各种属性都没有做进XFile中中，严格意义上的完全同步是无法做到的 采用递归来实现
    def FuncSync(self,mlocaldir1:str,mftpdir1:str)->int:
        global _debugmode
        global _ftp
        global _ftps
        global set_tls
        global _mbcon
        global set_syncmode
        global _bcomparemodtime
        global _bdeletedirfilesyncmode
        
        #mlocaldir 是本地目录
        #mftpdir 是远程服务器对应目录
        #扫描本地目录下所有内容先
        itotalsucc=0
        remoteobj=[]
        ##别问我为什么这么做
        mlocaldir=mlocaldir1
        mftpdir=mftpdir1
        
        #上面remote列表 是获取列表进行分解后保存 可以用来加速同步

        if(_debugmode):
            print("Local dir="+mlocaldir)
            print("Remote dir="+mftpdir)
        #执行次序 先切换到当前目录 如果切换失败 直接返回0
        #必须执行替换操作
        if(os.name=='nt'):
            mlocaldir.replace("/","\\")
            mlocaldir.replace("\\\\","\\")
            
        mftpdir.replace("//","/")

        if(_debugmode):
            print(mftpdir)
        if(self.FuncChangeCWD(mftpdir)==False):
            print("Failed change to work dir: " + mftpdir)
            print("Warning: " + mlocaldir + " ----Skipped")
            return 0    
            
        try:
            #万一出异常呢
            #     
            dirlist=os.listdir(mlocaldir)
            ###########如果是同步模型 那么需要先获取远程ftp(xfile)当前目录下的所有内容 然后先删除本地目录下不存在的目录和文件###############
            if(set_syncmode):
                #执行远程删除操作
                #fdata=[]
                fdata=self.FuncListDir(mftpdir)
                if(len(fdata)>0):
                    #执行远程删除操作 注意这个操作很危险 一般不建议使用同步模式 备份模式更安全
                    for fobj in fdata:
                        if(_debugmode):
                            print(fobj)
                        #执行分解操作
                        arr2=[]
                        arr2=str(fobj).strip().split('|')
                        #arr2 现在被分解成两个部分 前面是参数 后面是文件名或者目录名
                        if(len(arr2)!=2):
                            if(_debugmode):
                                print("Split list string failed :" +str(fobj))
                            continue
                        if(arr2[1]=='.' or arr2[1]=='..'):
                            #特殊目录必须跳过
                            continue
                        arr3=arr2[0].split( )
                        if(len(arr3)!=3):
                            if(_debugmode):
                                print("Split list string failed 2 :" + arr2[0])
                            continue
                        # 现在可以保证已经分解成功了
                        # arr3[0] 文件长度 16进制
                        # arr3[1] 如果为1 是文件 为0 则是目录
                        # arr3[2] 则是文件的最后修改时间 16进制s
                        # arr2[1] 则是文件名或者目录名  
                        # 采用元组的形式进行保存 格式 文件名 0=dir 文件长度 文件最后修改时间
                        if(int(arr3[1])!=0):
                            #只添加文件就可以了 目录没有用 采用元组的方式
                            #但是注意 我们默认是大小写敏感 如果要处理不敏感 可以将字符串改成大写或者小写 然后进行匹配
                            #但是毕竟绝大部分情况 这个代码跑的没有问题 哪怕是windows ntfs
                            if(_bcomparemodtime):
                                #如果使用最后修改时间
                                remoteobj.append((str(arr2[1]),int(arr3[1]),int(arr3[0],16),int(arr3[2],16)))
                            else:
                                #如果不使用最后修改时间
                                remoteobj.append((str(arr2[1]),int(arr3[1]),int(arr3[0],16),0))

                            #大小写不敏感采用下面的方式判断
                            #remoteobj.append((str(arr2[1]).lower( ),int(arr3[1]),int(arr3[0],16),int(arr3[2],16)))
                        
                        #如果你只想使用同步来加速判断文件目录是否存在 那么可以将下面的True改成 False 就不会执行同步下危险的删除动作了
                        #但是将保留同步获取远程目录下的文件目录列表 将来可以用来加速执行备份操作
                        #注意 这种获取列表的方式由于需要执行新的连接已经分解操作 如果一个目录下文件数很少，比如小于15个 代价是比较高的
                        #但是 如果同一个目录下例如存在几百几千的文件 用这种方式进行匹配可以节省很多额外操作时间
                        if(_bdeletedirfilesyncmode and set_syncmode):
                            #这里用个bool值做开关 方便用户根据自己的需要进行定制 例如只需要加速匹配 那么_bdeletedirfilesyncmode改成False就可以了
                            #那么检查该目录文件是否在当前本地目录中存在吧
                            #但是要注意 windows 目录名大小写不敏感 而Linux是大小写敏感 
                            #无法判断远程ftp的目标目录的磁盘到底是那种系统 
                            #我们这里采用了必须大小写敏感方式 这样简化操作 请根据自己的具体目标系统进行修改
                            #bdir1代表远程的目录或者文件是否存在本地，如果False不存在 那么同步模式下需要删除
                            bdir1=False
                            for s001 in dirlist:
                                #检查是否存在  
                                if(s001=='.' or s001=='..'):
                                    continue
                                if(s001==arr2[1]):
                                    #如果相同
                                    spf=os.path.join(mlocaldir,s001)
                                    pathfile=spf

                                    if(int(arr3[1])==0 and os.path.isdir(spf)):
                                        #这是目录 是的该目录存在
                                        bdir1=True
                                    elif(int(arr3[1])==1 and os.path.isfile(spf)):
                                        #这是文件 该文件存在
                                        bdir1=True    

                                else:
                                    continue    
                            if(bdir1==False):
                                #如果该远程目标并不在本地存在 那么删除该目标
                                #警告 这是个非常危险的操作 没有后悔药
                                #一般我们不建议你开启同步开关 因为万一设置错误 远程目录下的内容会被错误删除
                                if(_debugmode):
                                    print("Sync mode : now will try to delete remote obj:" + arr2[1])
                                if(int(arr3[1])==0):
                                    #这是目录
                                    if(self.FuncDelPathfile(arr2[1],False)==False):
                                        print("Sync mode : failed to delete dir: "+arr2[1])
                                else:
                                    if(self.FuncDelPathfile(arr2[1],True)==False):
                                        print("Sync mode : failed to delete file: "+arr2[1])
                                            


                        

            if(_debugmode and len(remoteobj)>0):
                #打印
                print("------remote ftp dir list ------")
                print(remoteobj)
                
            #同步模式结束            

            #########################同步操作完成#################################                

            for obj in dirlist:
                #打印
                if(_debugmode):
                    print(obj)
                if(obj=="." or obj==".."):
                    continue    
                    
                pathfile=os.path.join(mlocaldir,obj)
                if(os.path.isfile(pathfile)):
                    #这是个文件
                    #判断是否需要上传
                    #完整的本地目录是pathfile
                    #注意 需要先切换到当前目录 这里如果失败 就不可以上传文件 因为下面的子目录递归操作 将变动当前目录 因此必须切换
                    #因为本次循环只是单独处理文件 因此不需要重复的处理cwd
                    tup1=None
                    try:
                        #这里需要进行保护
                        st1=os.stat(pathfile)
                    except FileNotFoundError:
                        continue
                    except:
                        continue    
                    if(st1==None):
                        continue
                    if(len(remoteobj)>0):
                        #如果已经获取了目录下的列表 那么尝试快速匹配
                        if(_bcomparemodtime):
                            #如果采用最后修改时间
                            tup1=(str(obj),int(1),st1.st_size,int(st1.st_mtime))
                        else:
                            #如果不使用最后修改时间
                            tup1=(str(obj),int(1),st1.st_size,0)    
                        #大小写不敏感采用下面的方式
                        #tup1=(str(obj).lower(),int(1),st1.st_size,int(st1.st_mtime))
                        try:
                            #检查该文件是否存在 会抛出错误
                            if(remoteobj.index(tup1)>=0):
                            #如果该文件已经存在了
                                if(_debugmode):
                                    print("Sync mode , found file already exit , will skip --->" + obj)
                                    print(tup1)
                                print("----> Found file already exist , skip:" + obj)
                                continue  
                        except (ValueError):
                            pass
                        except :
                            pass

                          
                         
                             
                             
                    ####################注意这里 如果有特殊需求 例如windows环境下 允许文件名中包含空格 而XFile却是linux文件系统 那么应该在这里处理obj,例如用下划线代替空格等##############    
                    if(self.FuncUploadFile(obj,pathfile)<=0):
                        print("---->Upload file failed:" + pathfile)
                    else:
                        itotalsucc+=1
                    continue    
                elif(os.path.isdir(pathfile)):

                    continue   
                    #如果是目录 这里不处理 否则需要频繁处理目录切换 放到下一个循环去单独处理
                else:
                    continue    

            #第一个For 循环完成  下面执行第二个for 循环 创建子目录
            for obj in dirlist:
                #打印
                if(_debugmode):
                    print(obj)
                if(obj=="." or obj==".."):
                    continue    
                    
                pathfile=os.path.join(mlocaldir,obj)
                
                if(os.path.isdir(pathfile)):
                    #需要进行递归调用
                    #需要先创建改子目录 如果服务器上不存在的话
                    #obj 才是文件或者目录名
                    #注意 目录不能使用加速模式 需要采用递归
                    
                    ###############注意这里 如果有特殊需求 例如是windows环境 目录名中包含空格等字符 而XFile是linux文件系统 那么应该在这里处理远程obj 例如将空格用下划线进行取代等等#########
                    #####但是这样处理会需要大量的处理代码，万一已经存在同名带下划线的目录文件名怎么办？还原的时候怎么恢复空格等等，别问我，我也不知道，除非单独用个数据库去记录，否则我真不知道如何做
                    #####但是话说回来，会要求这种严格的完全同步场景的，我更推荐 linux下用tar 打包备份 windows 下用 7-zip打包 或者直接用文件系统特有的备份功能
                    str01=mftpdir+"/" + obj
                    str02=""
                    if(os.name=='nt'):
                        str02=mlocaldir+"\\"+obj
                        str02=str02.replace("/","\\")
                    else:
                        #如果是linux 那么就执行下面的    
                        str02=mlocaldir+"/" + obj
                    #这里 先要检查该目录是否存在
                    if(_debugmode):
                        print("Need loop call sync function")
                        print("str01 ftp dir="+str01)
                        print("str02 local dir="+str02)
                    if(self.FuncChangeCWD(str01)==False):
                        #那么创建该目录吧
                        #这里需要先切换到当前目录
                        if(_debugmode):
                            print("Current mftpdir="+mftpdir)
                        if(self.FuncChangeCWD(mftpdir)==False):
                            print("Error: failed to change cwd to: "+mftpdir)
                            print("******** skip :" + str02)
                            continue
                        if(self.FuncMakeSingleDir(obj)==False):
                            print("Error: Fail to create sub dir -> "+obj)
                            continue
                        else:
                            #否则 执行上传操作
                            if(_debugmode):
                                print("Success make sub dir:" + obj)
                            itotalsucc+=self.FuncSync(str02,str01)    
                    else:
                        #目录已经存在了
                        if(_debugmode):
                            print("Found sub dir alreay exist, will call sync next "+str01)
                        itotalsucc+=self.FuncSync(str02,str01)  

                    
                else:
                    continue                       

                    
                           

        except Exception  as e:
            print("Unknown error in listdir call:" + e)
            return -1

        return itotalsucc     




                    

                 

            
                        

                    
                    




                             

    

             

##下面是主程序
                
if __name__ == '__main__':
    # When this module is run (not imported) then create the app
    # 
    
    print("Programed by danscort yu ")
    print("www.phoenixp2p.com")
                                
